OpenTTD Source: HeaderFileWriter Struct Reference

OpenTTD Source 15.3

Public Member Functions | Data Fields
HeaderFileWriter Struct Reference
Inheritance diagram for HeaderFileWriter:

## Public Member Functions
| HeaderFileWriter (const std::filesystem::path &path)
| Open a file to write to.
void | WriteStringID (const std::string &name, size_t stringid) override
| Write the string ID.
void | Finalise (const StringData &data) override
| Finalise writing the file.
Public Member Functions inherited from HeaderWriter
virtual | ~HeaderWriter ()=default
| Especially destroy the subclasses.
void | WriteHeader (const StringData &data)
| Write the header information.
Public Member Functions inherited from FileWriter
| FileWriter (FileHandle &&file)
| Create the file writer, so it writes to a specific file.
| ~FileWriter ()
| Make sure everything is cleaned up.
void | Write (uint8_t *buf, size_t size) override
| Write a given number of bytes into the savegame.
void | Finish () override
| Prepare everything to finish writing the savegame.
| FileWriter (const std::filesystem::path &path, std::ios_base::openmode openmode)
| Open a file to write to.
void | Finalise ()
| Finalise the writing.
virtual | ~FileWriter ()
| Make sure the file is closed.
Public Member Functions inherited from SaveFilter
| SaveFilter (std::shared_ptr< SaveFilter > chain)
| Initialise this filter.
virtual | ~SaveFilter ()=default
| Make sure the writers are properly closed.

## Data Fields
const std::filesystem::path | real_path
| The real path we eventually want to write to.
size_t | prev
| The previous string ID that was printed.
size_t | total_strings
Data Fields inherited from FileWriter
std::optional< FileHandle > | file
| The file to write to.
std::ofstream | output_stream
| The stream to write all the output to.
const std::filesystem::path | path
| The file name we're writing to.
Data Fields inherited from SaveFilter
std::shared_ptr< SaveFilter > | chain
| Chained to the (savegame) filters.

## Detailed Description

Definition at line 217 of file strgen.cpp.

## Constructor & Destructor Documentation

## ◆ HeaderFileWriter()

HeaderFileWriter::HeaderFileWriter | ( | const std::filesystem::path & | path | ) |
| inline

Open a file to write to.

Parameters

  path | The path to the file to open.

Definition at line 228 of file strgen.cpp.

References FileWriter::output_stream.

## Member Function Documentation

## ◆ Finalise()

void HeaderFileWriter::Finalise | ( | const StringData & | data | ) |
| inlineoverridevirtual

Finalise writing the file.

Parameters

  data | The data about the string.

Implements HeaderWriter.

Definition at line 244 of file strgen.cpp.

References _plural_forms, FileWriter::Finalise(), FileWriter::output_stream, FileWriter::path, and StringData::Version().

## ◆ WriteStringID()

void HeaderFileWriter::WriteStringID | ( | const std::string & | name,
|  | size_t | stringid
| ) |  |
| inlineoverridevirtual

Write the string ID.

Parameters

  name | The name of the string.
  stringid | The ID of the string.

Implements HeaderWriter.

Definition at line 236 of file strgen.cpp.

References FileWriter::output_stream, and prev.

## Field Documentation

## ◆ prev

size_t HeaderFileWriter::prev

The previous string ID that was printed.

Definition at line 221 of file strgen.cpp.

Referenced by WriteStringID().

## ◆ real_path

const std::filesystem::path HeaderFileWriter::real_path

The real path we eventually want to write to.

Definition at line 219 of file strgen.cpp.

## ◆ total_strings

size_t HeaderFileWriter::total_strings

Definition at line 222 of file strgen.cpp.

The documentation for this struct was generated from the following file:

- src/strgen/strgen.cpp